/* hrr_vectors_TEST1.pl */


/*
Run these tests by loading autotest and 
then loading this file.
*/


:- module( hrr_vectors_TEST1, [
                              ]
         ).


:- use_module( hrr(hrr_vectors) ).


:- '$test'(( D=10000
           , hrr_vector_random( D, A )
           , hrr_vector_random( D, B )
           , hrr_vector_bind( A, B, AB ), hrr_vector_probe( AB, B, A2 )
           , A == A2
           ) :: s
          ).

:- '$test'(( D=10000
           , hrr_vector_random( D, A )
           , hrr_vector_random( D, B )
           , hrr_vector_bind( A, B, AB ), hrr_vector_probe( AB, A, B2 )
           , B == B2
           ) :: s
          ).

:- '$test'(( D=10000
           , hrr_vector_random( D, A )
           , hrr_vector_random( D, B )
           , hrr_vector_dot( A, A, D, A_Dot_A ), A_Dot_A = 1
           , hrr_vector_dot( B, B, D, B_Dot_B ), B_Dot_B = 1
           , hrr_vector_dot( A, B, D, A_Dot_B ), A_Dot_B < 1
           , hrr_vector_dot( B, A, D, B_Dot_A ), B_Dot_A < 1
           ) :: s
          ).

:- '$test'(( D=10000
           , hrr_vector_random( D, Capital )
           , hrr_vector_random( D, Paris )
           , hrr_vector_random( D, Location )
           , hrr_vector_random( D, WE )
           , hrr_vector_random( D, Money )
           , hrr_vector_random( D, Euro )
           , hrr_vector_bind( Capital, Paris, CP )
           , hrr_vector_bind( Location, WE, LWE )
           , hrr_vector_bind( Money, Euro, ME )
           , hrr_vector_merge( [CP,LWE,ME], France )
           , hrr_vector_probe( France, Capital, CF )
           , hrr_vector_dot( CF, Paris, D, CF_Dot_Paris )
           , forall( member( Vec, [Capital,Location,WE,Money,Euro] )
                   , ( hrr_vector_dot( CF, Vec, D, CF_Dot_Vec )
                     , CF_Dot_Paris > CF_Dot_Vec
                     )
                   )
           ) :: s
          ).

